#!/usr/bin/perl  
# $Id
# sasacct.cgi
# reguires CGI::Session to run

use strict;
use CGI::Carp('fatalsToBrowser');
use CGI::Pretty qw(:all *table);
use CGI::Cookie;
use CGI::Session;
use Time::Local;
use IO::Handle;

#######################
# some globals
#
my $configfile = "/etc/sasacct.conf";
my $logopath = '/sasacct';
my $userfile = '/etc/sasacct.users';
my @ips;
my (%rkeys,%users,%local);
my ($sec,$min,$hour,$mday,$mon,$year) = localtime();
my $system_time = sprintf("%04d%02d%02d% 02d%02d%02d", ($year+1900), $mon+1, $mday, $hour, $min, $sec);
my @years = (2001,2002,2003,2004);
my %mlabels= (  '01' => 'Jan','02' => 'Feb','03' => 'Mar',
                '04' => 'Apr','05' => 'May','06'=>'Jun',
                '07' => 'Jul', '08' =>  'Aug','09' => 'Sep',
                '10' => 'Oct',11=>'Nov',12 => 'Dec'
			);
my @months =('01','02','03','04','05','06',
             '07','08','09','10','11','12'
			);
my @days = qw(01 02 03 04 05 06 07 08 09 10 11 12 13 14 15
              16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31
			);

##################
# define session
#
my $cgi = new CGI;
my $session = new CGI::Session(undef, $cgi, {Directory=>'/tmp'});
my $cookie = $cgi->cookie(CGISESSID => $session->id );

#################
# get cgi params
#
my $utcstart = $cgi->param('utcstart');
my $utcend = $cgi->param('utcend');
my $fpathrrd = $cgi->param('file');
my $bits= $cgi->param('bits');
my $zoom = $cgi->param('zoom');
my $rrd = $cgi->param('rrd');
my $startdate=(param('syear').param('smonth').param('sday'));
my $enddate=(param('eyear').param('emonth').param('eday'));
my $dograph = $cgi->param('graph');
my $bits = $cgi->param('bits');
my $zoom = $cgi->param('zoom');
my $ip = $cgi->param('ip');
my $login = $cgi->param('login');
my $user =  $cgi->param('user');
my $password = $cgi->param('password');
my $sdateformated = (param('sday').'-'.param('smonth').'-'.param('syear'));
my $edateformated = (param('eday').'-'.param('emonth').'-'.param('eyear'));

###################
# print graphic
#
if ($rrd == 1) {
	print $cgi->header(
		-type=>'image/png', 
		-expires => 'now',
		-Cache-Control=>'no-cache');
	&show_graph($utcstart,$utcend,$fpathrrd,$bits,$zoom);
	exit;
}

###################
# parse configfile
open(CNF,"$configfile");
while(<CNF>) {
        if ($_ =~ /^D/ && !exists($rkeys{D})) {
        chop $_;
        s/^D://g;
		s/\/$//g;
        $_ = $_."\/";
		$rkeys{D} = $_;
        }
        if ($_ =~ /^L/){
        chop $_;
        s/^L://g;
        my ($ip,@i)=split(/:/,$_);
        $local{$ip}= \@i if !defined($local{$ip});
        }
}
close CNF;

#########################
# parse users file
open(USERS,"<$userfile")
        || croak("missing users file");
        
while (<USERS>) {
    next if $_ =~ /^#/g;
    next if $_ =~ /^\s+/g;
    /(.*)\:(.*)\:(.*)/;
    $users{$1}->{password} = $2;
    $users{$1}->{ip} = $3;
}

#############
#	main	#	
#############
init($session,$cgi);
if ( $session->param("~login-trials") >= 3 ) {
	print $cgi->header();
	print_head();
    print p('You failed 3 times to log in.<br>
			Your session is <b>logged</b>.'
			);
	print_foot();
    exit(0);
}

unless ( $session->param("~logged-in") ) {
    print $cgi->header(-cookie=>$cookie);
    print_head();
    print gen_auth();
    print_foot();
    exit(0);
}
if (stat($rkeys{D})) {
    opendir DIR,$rkeys{D} || die ("Cannot open: $!");
    my @files = readdir(DIR);
    closedir DIR;
    for(@files) {
        if ($_ =~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}(\_\d+)*?$/
            && $_ !~ /rrd/g){
            push @ips,$_;
        }
    }
}

@ips = sort @ips;
push @ips,"All";

############################
# If user is not admin 
# put in @ips the ips that 
# he/she is able to view.
# The All keyword scopes only
# for them.
my $profile = $session->param("~profile");
if ($profile->{username} !~ /admin/) {
	@ips = split (/,/,$users{$profile->{username}}->{ip});
}

if ($startdate && $enddate) {
	$|=1;
	print header();
	print_head();
	&print_page($startdate,$enddate,$ip,\@ips);
	print_foot();
	exit(0);
}

print header();
print_head();
print &gen_form();
print_foot();



#########################
#       functions		#
#########################

##############################
# from CGI::Session::CookBook
sub init {
    my ($session, $cgi) = @_;
    if ( $session->param("~logged-in") ) {
        return 1;
    }
    my $lg_name = $cgi->param("user") or return;
    my $lg_psswd= $cgi->param("password") or return;

    if ( my $profile = check_password($lg_name, $lg_psswd) ) {
        $session->param("~profile", $profile);
        $session->param("~logged-in", 1);
        $session->clear(["~login-trials"]);
        return 1;
    }
    my $trials = $session->param("~login-trials") || 0;
    return $session->param("~login-trials", ++$trials);
}

##################
# check password
#
sub check_password {
    my ($u,$p) = @_;
    my $i;
    if ($users{$u}->{password} eq $p) {
        my $p_mask = "x" . length($p);
        return { username=>$u, password=>$p_mask, ip=> $i};
    }
    return undef;
}

sub gen_form{
	return startform( -method => 'POST'),
	center,p({class=>"title"},'<b>Start Date [YYYY/MM/DD]</b>'),
	popup_menu(-class =>'input',-name => 'syear', -values => \@years,-Default=>$years[2]),
	popup_menu(-class =>'input',-name=>'smonth', -values=> \@months, -labels=> \%mlabels),
	popup_menu(-class =>'input',-name => 'sday', -values=> \@days),
	p({class=>"title"},'<b>End Date [YYYY/MM/DD]</b>'),
	popup_menu(-class =>'input',-name => 'eyear', -values => \@years, -Default=>$years[2]),
	popup_menu(-class =>'input',-name=>'emonth', -values => \@months , -labels => \%mlabels),
	popup_menu(-class =>'input',-name => 'eday', -values=> \@days),
	p({class=>"default"}),
	checkbox(-class => "default", -name=>'graph',-label => 'Generate graphics for the selected period'),
	p({class=>"default"}),checkbox(-name=>'bits',-label  => 'Show graph in Bits per Second'),
	p({class=>"default"}),checkbox(-name=>'zoom',-label => 'Zoom the graphic'),
	p({class=>"title"},'<b>[Select IP Address]</b>'),
	p,popup_menu(-class =>'input',-name => 'ip', -values=>\@ips),
	p,submit(-class=>'input',-value => 'Submit'),'&nbsp','&nbsp',
	reset(-class=>'input',-value => 'Reset'),
	endform;
}

sub gen_auth() {
    return startform(-method =>'POST'),
    center,
	start_table({-celpadding => '0' ,-class=>'default', -cellspacing =>'0' , -border => '1'}),
	Tr,td,
    start_table({-celpadding => '0' ,-class=>'default', -cellspacing =>'0' , -border => '0'}),
	Tr,td,p({class=>"title"},'<b>Username</b>'),td,textfield(-name=>'user'),br,
	Tr,td,p({class=>"title"},'<b>Password</b> '),td,input({-name=>'password', -type=>'password'}),br,
	Tr({-valign =>"middle",-align =>"middle"}),td,td,submit(-class=>'input',-value => 'Submit'),'&nbsp','&nbsp',
    reset(-class=>'input',-value => 'Reset'),end_table,end_table,
	endform;
}

sub gen_traff($$\@$) {
	my($start,$end,$ips,$ip)= @_;
	my %bytes;
	if ($ip eq "All") {
		&gen_traff_all($start,$end,$ips);
	} else {
        open(IN,"$rkeys{D}"."$ip") if stat("$rkeys{D}"."$ip");
        my $line = <IN>;
        chop $line;
        while (defined($line)) {
        	my ($date,$time,$ip,$in,$out) = split(/\s+/,$line);
        	if ($date ge $start && $date le $end ) {
            	$bytes{in} += $in;
        	    $bytes{out} += $out;
        	}
        	$line = <IN>;
        }
        return $bytes{in},$bytes{out};
        }
}

sub gen_traff_all() {
    my($start,$end,$ips) = @_;
    my %bytes;
    foreach (@$ips){
        open (IN,"$rkeys{D}"."$_") if stat("$rkeys{D}"."$_") ;
        my $line = <IN>;
        chop $line;
        while ( defined($line)) {
        my ($date,$time,$ip,$in,$out) = split(/\s+/,$line);
            if ($date ge $start && $date le $end ) {
                $bytes{in} += $in;
                $bytes{out} += $out;
            }
        $line = <IN>;
        }
    }
    return $bytes{in},$bytes{out};
}

sub print_page ($$$\@) {
	my ($startdate,$enddate,$ip,$ips) = @_;
	if (defined($startdate) && defined($enddate)) {
   		my ($in,$out) = &gen_traff($startdate,$enddate,$ips,$ip);
    	print &gen_form();
    	#print hr;
    	if (defined($in) && defined($out)){
    	print center,
    	p({class=>"default"},"Total traffic from <b>$sdateformated</b> to <b>$edateformated</b> for $ip ($local{$ip}[0])");
    	my $total = $in+$out;
    	my $totalmb = sprintf("%.3f", $total/1024/1024);
    	print table({-celpadding => '0' ,-class=>'default', -cellspacing =>'0' , -border => '1'},
    	Tr({-bgcolor=> '#C0C0C0'},
    	th(['Ip Number','Input Traffic[bytes]','Output Traffic[bytes]',
        	'Total [bytes]','Total [MBytes]'])),
    	Tr({-valign =>"middle",-align =>"middle"},
    	td(["$ip","$in","$out","$total","$totalmb"])));
    	}
    	# Decide what will we graph
    	if ($dograph eq 'on' && $ip ne "All" ){
    	my $utcstart  = timelocal('00','00','00',param('sday'),param('smonth')-1,param('syear'));
        my $utcend = timelocal('00','00','00',param('eday'),param('emonth')-1,param('eyear'));
    	($utcend = $utcstart + 86000) if ($utcstart == $utcend);
    	($bits eq "on") ? ($bits = 1) : ($bits = 0);
    	($zoom eq "on") ? ($zoom = 1): ($zoom = 0);
   		my $fpathrrd = $rkeys{D}.param('ip').".rrd";
    	print br,br;
    	#On the fly graph goes here.
    	if ( -f ("$fpathrrd") && ($utcstart < $utcend)) {
		my $myself = $cgi->url(-relative);
    	print img({-src => "$myself?rrd=1&utcstart=$utcstart&utcend=$utcend&file=$fpathrrd&bits=$bits&zoom=$zoom"});
       	}
    }
    print br,br;
	} else {
   		print &gen_form();
	}
}

#######################
# head and foot 
sub print_head {
print start_html(
-title => 'SASacct Accounting Statistics',
-head=>meta({-http_equiv => 'Page-enter',-content=>'filter: blendtrans(duration=0.5)'}),
-style => (
'.title {font-family:Verdana,Helvetica,Arial,sans-serif; font-size: 12px; font-weight: normal; color: #666666}
.default {font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; color: #000000}
.small {font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 9.5px; color: #666666}
#.input {background: #FFFFFF; font-family:Verdana,Arial,Helvetica;font-size: 8pt; border: 1px solid #666666; padding: 1px;color: #666666}
.select {background: #ffffff; FONT-FAMILY: verdana; FONT-SIZE: 12pt; border: 1px solid black; padding: 2px;color: #000000}
.negative {color: #FFFFFF; background-color: #666666; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px}'
),
-bgcolor => '#FFFFFF', -text =>'#666666', -vlink =>'#666666', -alink =>'#009900' -link =>'#333333'
);
print center,img({src=>"$logopath/salogo.gif"}),
p({-class=>"title"},'<b>[Traffic Statistics]</b>');
print hr;

}

sub print_foot {
print hr;
print qq~ <center><a href="http://rousse.pm.org/sasacct/" target="_blank"><img border="0" src="$logopath/poweredbysa.gif"></a></center>
~
;
print end_html();
}

##########################
# print graphic
#

sub show_graph {
	my($utcstart,$utcend,$fpathrrd,$bits,$zoom) = @_;
	my (@header_str,@def_str,@data_str,@comment_str);
	@header_str = (
	"--title","Traffic Stats",
	"--imgformat","PNG",
	"--start","$utcstart",
	"--end","$utcend",
	"--color","FRAME#FFFFFF",
	"--color","SHADEA#FFFFFF",
    "--color","SHADEB#FFFFFF",
    "--color","BACK#FFFFFF",
	);
	if ($zoom == 1) {
		push @header_str,("-w","600","-h","150");
	}
	if ($bits == 1){
	@def_str = ( 
	"DEF:indatabits=$fpathrrd:in:AVERAGE",
    "DEF:outdatabits=$fpathrrd:out:AVERAGE",
	"CDEF:indata=indatabits,8,*",
    "CDEF:outdata=outdatabits,8,*",
    "CDEF:averagein=indata,UN,0,indata,IF",
    "CDEF:averageout=outdata,UN,0,outdata,IF"
	);
	push @header_str,(
	"--vertical-label",
	"Bits per second","--base","1000",
	"--units-exponent","3",
	"--alt-y-grid",
	"--lower-limit","0"
	);
	}else {
	@def_str =(
	"DEF:indatabytes=$fpathrrd:in:AVERAGE",
	"DEF:outdatabytes=$fpathrrd:out:AVERAGE",
	"CDEF:indata=indatabytes",
    "CDEF:outdata=outdatabytes",
    "CDEF:averagein=indatabytes,UN,0,indatabytes,IF",
    "CDEF:averageout=outdatabytes,UN,0,outdatabytes,IF",
	);
	push @header_str,("--vertical-label","Bytes per second");
	}

	@data_str = ("AREA:averagein#00CC00:In",
	"GPRINT:indata:AVERAGE:Avg\\:%8.2lf%s",
	"GPRINT:indata:MIN:Min\\:%8.2lf%s",
	"GPRINT:indata:MAX:Max\\:%8.2lf%s",
	"GPRINT:indata:LAST:Current\\:%8.2lf%s\\n",
	"LINE1:averageout#0000FF:Out",
    "GPRINT:outdata:AVERAGE:Avg\\:%8.2lf%s",
    "GPRINT:outdata:MIN:Min\\:%8.2lf%s",
    "GPRINT:outdata:MAX:Max\\:%8.2lf%s",
    "GPRINT:outdata:LAST:Current\\:%8.2lf%s\\n"
	);
	@comment_str = ("COMMENT:Generated by sasacct http://rousse.pm.org/sasacct\\c");
	require 'RRDs.pm';
	#don't buffer output 
	$|=1;
    RRDs::graph("-",@header_str,@def_str,@data_str,@comment_str);
}
